//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladen"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Orange
#property indicator_width1  2
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1  70
#property indicator_level2  30

extern int Length   = 14;
extern int Price    = PRICE_CLOSE;
extern int MaMethod = MODE_SMMA;

double rsi[];
double mom[];
double moa[];

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0,rsi);
      SetIndexBuffer(1,mom);
      SetIndexBuffer(2,moa);
         IndicatorShortName("Rsi experiment ("+Length+")");
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      mom[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,1,0,MODE_SMA,Price,i+1);
      moa[i] = MathAbs(mom[i]);
   }      
   for(i=limit; i>=0; i--)
   {
      double tmom = iMAOnArray(mom,0,Length,0,MaMethod,i);
      double tmoa = iMAOnArray(moa,0,Length,0,MaMethod,i);
      if (tmoa != 0)
           rsi[i] = MathMax(MathMin((tmom/tmoa+1.0)*50.0,100.00),0.00); 
      else rsi[i] = 50;
   }
   return(0);
}